﻿# -*- coding: utf-8 -*-
import xbmcplugin, xbmcgui
import urllib, urllib2, urlparse
from xml.dom.minidom import parseString
import json
import re
import time
import md5

def httpget(url):
	try:
		file = urllib2.urlopen(url, timeout = 3)
		content = file.read()
		file.close()
		return content
	except:
		print url
		print 'captured'
		return False

def item(title, url, isFolder = True):
	listitem = xbmcgui.ListItem(title)
	xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urllib.urlencode({'url': url}), listitem, isFolder)

def play(title, url):
	listitem = xbmcgui.ListItem(title)
	xbmc.Player().play(url, listitem)

def getiqiyi(url):
	pDialog = xbmcgui.DialogProgress()
	pDialog.create('获取列表')
	pDialog.update(0, '正在获取信息...', url)
	content = httpget(url)
	if pDialog.iscanceled():
		pDialog.close()
		return
	if content == False:
		pDialog.close()
		xbmcgui.Dialog().ok('错误', '错误201')
		return
	sourceid = re.search('sourceId:\s*(\d*)', content)
	if sourceid == None:
		sourceid = re.search('data-player-albumid="(\d*)"', content)
		if sourceid == None:
			pDialog.close()
			xbmcgui.Dialog().ok('错误', '错误202')
			return
	sourceid = sourceid.group(1)
	cid = re.search('cid:\s*(\d*)', content)
	if cid == None:
		cid = '6'
	else:
		cid = cid.group(1)
	url = 'http://cache.video.qiyi.com/jp/sdvlst/' + cid + '/' + sourceid + '/'
	pDialog.update(50, '正在获取信息...', url)
	content = httpget(url)
	if pDialog.iscanceled():
		pDialog.close()
		return
	if content == False:
		pDialog.close()
		xbmcgui.Dialog().ok('错误', '错误203')
		return
	content = re.search('var tvInfoJs=(.*)', content)
	if pDialog.iscanceled():
		pDialog.close()
		return
	if content == None:
		pDialog.close()
		xbmcgui.Dialog().ok('错误', '错误204')
		return
	content = content.group(1)
	try:
		data = json.loads(content)
	except:
		pDialog.close()
		xbmcgui.Dialog().ok('错误', '错误205')
		return
	for tv in data['data']:
		item(tv['tvYear'] + tv['tvSbtitle'], tv['vUrl'], False)
	xbmcplugin.endOfDirectory(handle)
	pDialog.update(100, '完成')
	pDialog.close()

def playiqiyi(url):
	def getDispatchKey(var1, var2):
		var3 = ')(*&^flash@#$%a'
		var4 = str(int(var1) / 600)
		m1 = md5.new()
		m1.update(var4 + var3 + var2)
		return m1.hexdigest()

	pDialog = xbmcgui.DialogProgress()
	pDialog.create('获取视频')
	pDialog.update(0, '正在获取信息...', url)
	content = httpget(url)
	if pDialog.iscanceled():
		return
	if content == False:
		pDialog.close()
		xbmcgui.Dialog().ok('错误', '错误301')
		return
	tvid = re.search('tvid="(.*?)"', content)
	if tvid == None:
		pDialog.close()
		xbmcgui.Dialog().ok('错误', '错误302')
		return
	tvid = tvid.group(1)
	videoid = re.search('videoid="(.*?)"', content)
	if videoid == None:
		pDialog.close()
		xbmcgui.Dialog().ok('错误', '错误303')
		return
	videoid = videoid.group(1)
	#url = 'http://cache.video.qiyi.com/vd/' + tvid + '/' + videoid + '/'
	url = 'http://cache.video.qiyi.com/vp/' + tvid + '/' + videoid + '/'
	pDialog.update(20, '正在获取信息...', url)
	content = httpget(url)
	if pDialog.iscanceled():
		return
	if content == False:
		pDialog.close()
		xbmcgui.Dialog().ok('错误', '错误304')
		return
	try:
		data = json.loads(content)
	except:
		pDialog.close()
		xbmcgui.Dialog().ok('错误', '错误305')
		return
	timestamp = str(int(time.time()))
	i = 0
	l = len(data['tkl'][0]['vs'][0]['fs'])
	for fs in data['tkl'][0]['vs'][0]['fs']:
		j = 40 + 60 * i / l
		k = i + 1
		s = '正在获取信息: ' + str(k) + ' / ' + str(l) + '...'
		url = data['dd'] + fs['l']
		cid = re.search('/.*/(.*?)\.f4v', url)
		if cid == None:
			pDialog.close()
			xbmcgui.Dialog().ok('错误', '错误306')
			return
		cid = cid.group(1)
		dispatchkey = getDispatchKey(timestamp, cid)
		url = url.replace('/videos/', '/' + dispatchkey + '/videos/') + '?su=1fee5e003ce6bce6968ca03273435564'
		pDialog.update(j, s, url)
		if pDialog.iscanceled():
			return
		content = httpget(url)
		if content == False:
			pDialog.close()
			xbmcgui.Dialog().ok('错误', '错误307')
			return
		try:
			data2 = json.loads(content)
		except:
			pDialog.close()
			xbmcgui.Dialog().ok('错误', '错误308')
			return
		url = data2['l']
		if i == 0:
			result = url
		else:
			result = result + ' , ' + url
		i = i + 1
	pDialog.update(100, '完成')
	pDialog.close()
	if i > 1:
		play('', 'stack://' + result)
	elif i > 0:
		play('', result)

handle = int(sys.argv[1])
if sys.argv[2] == '':
	url = 'http://ims.tian-le.com/iqiyi.php'
	content = httpget(url)
	if content == False:
		xbmcgui.Dialog().ok('错误', '错误000')
		sys.exit(0)
	dom = parseString(content)
	for element in dom.getElementsByTagName('item'):
		title = element.getElementsByTagName('title')[0].firstChild.nodeValue
		url = element.getElementsByTagName('url')[0].firstChild.nodeValue
		if re.match(r'http://www\.iqiyi\.com/a_.*\.html', url):
			item(title, url)
		elif re.match(r'http://www\.iqiyi\.com/v_.*\.html', url):
			item(title, url, False)
	xbmcplugin.endOfDirectory(handle)
else:
	url = urlparse.parse_qs(urlparse.urlparse(sys.argv[2]).query)['url'][0]
	if re.match(r'http://www\.iqiyi\.com/a_.*\.html', url):
		getiqiyi(url)
	elif re.match(r'http://www\.iqiyi\.com/v_.*\.html', url):
		playiqiyi(url)
	else:
		xbmcgui.Dialog().ok('错误', '错误000')
